#ifndef __PRECORDER__INC
#define __PRECORDER__INC

#ifdef __PRECORDER__DBG
#define _icebp _asm int 1
#else
#define _icebp
#endif

#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <vector>


//
//
// Current Process Recorder class
//
class CPRecorder
{
public:
  // data types
  typedef enum { rsIdle, rsRecording, rsPlaying} eRecorderState;
  typedef std::vector<EVENTMSG> tEventMsgStream;
  enum { reOk = 0, reNotIdle, reEmpty, rePlaybackHook, reRecorderHook};

  // Data members
  static tEventMsgStream Stream;
  static tEventMsgStream::iterator StreamPtr;
  static eRecorderState State;
  static long SpeedFactor;
  static HINSTANCE hInstance;

  // callback for filtering messages
  static bool (*RecordThisMessage)(EVENTMSG &Msg);

	// public methods
  CPRecorder();
	static bool   load_stream(LPCTSTR FileName);
	static bool   save_stream(LPCTSTR);
	static void   DoStop();
	static int    DoRecord(bool bAppend = false);
  static int    DoPlay();

private:
  //
	static EVENTMSG EventMsg;
  static HHOOK HookHandle;
  static long BaseTime;
  // Callbacks for recording/playback
	static LRESULT WINAPI PlayProc(int code, WPARAM wParam, LPARAM lParam);
	static LRESULT WINAPI RecordProc(int code, WPARAM wParam, LPARAM lParam);
  // 
	static void SetState(eRecorderState newState);
	static inline bool DefaultRecordAllMessages(EVENTMSG &msg);
};

#endif